//
// Created by scoliono on 10/14/23.
//

#ifndef FEMMAPS_SIGALERTROAD_H
#define FEMMAPS_SIGALERTROAD_H

#include "SigalertRoadSection.h"
#include "SigalertRoadSensor.h"
#include "../include/IntervalTree.h"

class SigalertRoad {

public:
    SigalertRoad();
    const std::vector<SigalertRoadSection>& sections();
    const std::vector<SigalertRoadSensor>& sensors();
    const IntervalTree<int, int>& speedLimits();
    int id();

private:
    void populateRoadSections();
    void populateRoadSensors();

    int m_id;
    std::string m_name;
    std::vector<SigalertRoadSection> m_sections;
    std::vector<SigalertRoadSensor> m_sensors;
    IntervalTree<int, int> m_sensor_speedlimits;
};


#endif //FEMMAPS_SIGALERTROAD_H
